/***********************************************************************
 
  This program creates a (Full backup) of your 'c:\home' directory 
  to the directory, 'x:\RsyncBackup\Local\Backups\Full' using rsync.exe
 
  Greggory Shaw, USA, Nov 2016


  This script serves as a template for RsyncBackup. Make a copy of 
  this program to User_Scripts diectory, then modify to suit your needs.

  This script uses the --delete option, so be care that you understand
  that the --delete option makes a complete backup and syncs the source 
  and destination directories. 

  If you delete something in the source directory, it gets deleted in 
  the destination directory (so be careful) on the next run. 
  
  If you just want a snapshot (copy), use the HomeDir-Copy_Local.cmd

  WARNING - DO NOT USE (--delete) ON ROOT (\)

  ---

  Change 'c:\home' to the directory that you want to make a FULL COPY.

      BackupDirectory= 'c:\home'
 

  Change 'BackupDir' to your desired backup location .

      BackupLocation=BackupDir


  USAGE: stand alone or remove the statement, 'Call Banner' for 
  automated backups with a scheduler.

  
  REMEMBER: remove the --dry-run option to ENABLE actual changes.


 *** DO NOT MODIFY (UPGRADING WILL OVERWRITE), COPY TO USER_SCRIPTS  ***
  
 ***********************************************************************/


Call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
Call SysLoadFuncs

Version='1.1'

CurrentDir = directory()

parse var CurrentDir NewDir "\Local_Scripts" . 
BackupDir = NewDir || '\Backups\Local\Full'


/***********************************************************************
 * Directory to backup !!                                              *
                                                                       */
BackupDirectory= 'c:\home'


/***********************************************************************
 * Location where the backup is saved, this directory must exist!!     *
                                                                       */
BackupLocation=BackupDir /*** DO NOT SET THIS TO ROOT (\)              */


/***********************************************************************
 * The name of the Rsync backup server                                 *
                                                                       */
BackupServer=localhost


/***********************************************************************
 * excludes file - per line of files to exclude                        *
                                                                       */
 
FilterList = '--filter=._filters.home ' 


/***********************************************************************
 * Options for Rsync & Banner                                          *
                                                                       */
opts = ' --dry-run --archive --itemize-changes --os2-perms --stats --xattrs --delete-during '
logs = '--log-file=%LOGFILES%\rsyncd.log '

Call CColor
Call Banner


/***********************************************************************/
/* Now for the actual transfer !                                       */
/***********************************************************************/

rsync || opts || FilterList || logs || BackupDirectory || ' ' || BackupLocation 

say ''
say 'Done!'

"pause"

EXIT 0;


CColor:

/***********************************************************************
 * Set some colors, thanx to Dmitry A.Steklenev for the inspiration    *
 * enable ANSI extended screen and keyboard control                    *
                                                                       */
'@ansi on > nul'
color.brown   = "1B"x"[0;33m"
color.red     = "1B"x"[1;31m"
color.green   = "1B"x"[1;32m"
color.yellow  = "1B"x"[1;33m"
color.blue    = "1B"x"[1;34m"
color.magenta = "1B"x"[1;35m"
color.cyan    = "1B"x"[1;36m"
color.white   = "1B"x"[1;37m"
color.gray    = "1B"x"[0m"

RETURN


Banner:

/***********************************************************************/ 

say color.gray  || 'Thank you for using '|| color.magenta || 'RsyncBackup' ||,
color.gray || ', a backup tool for your Os2/eCS system.'

say color.cyan || 'Version 'Version || color.gray || ' - 21 Nov 2016, ' || 'Copyright (c) 2016 by '|| color.green || 'Greggory Shaw'

say ''
say color.gray || "This program creates a 'FULL' copy of the directory: " || color.green ||,
 BackupDirectory || color.gray

say ''
say 'The Rsync commandline:'

say 'Rsync ' || color.green || opts || FilterList || logs || BackupDirectory || ' ' || BackupLocation || color.gray

say ''
say 'The files will be located in: '
say  color.green || BackupDir || color.gray
say ''
say 'This script uses the --delete option, so be care that you understand'
say 'that the --delete option makes a complete backup and syncs the source' 
say 'and destination directories.' 
say ''
say 'If you delete something in the source directory, it gets deleted in' 
say 'the destination directory (so be careful) on the next run.'
say ''
say 'If you just want a snapshot (COPY), use the HomeDir-Copy_Local.cmd script.'
say ''
say color.red || 'Continue? Y/n' || color.gray

pull YesNo
if \ (YesNo = "Y") then exit

RETURN